"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/**
 * [`@babel/preset-env`](https://babeljs.io/docs/en/next/babel-preset-env) is a smart preset that allows you to use the latest JavaScript without
 * needing to micromanage which syntax transforms (and optionally,
 * browser polyfills) are needed by your target environment(s).
 * This both makes your life easier and JavaScript bundles smaller!
 */
function _default(context, options, env) {
  var _options$typescript = options.typescript,
      typescript = _options$typescript === void 0 ? true : _options$typescript,
      targets = options.targets,
      presetReact = options.presetReact,
      _options$loose = options.loose,
      loose = _options$loose === void 0 ? false : _options$loose,
      _options$modules = options.modules,
      modules = _options$modules === void 0 ? 'auto' : _options$modules,
      _options$useBuiltIns = options.useBuiltIns,
      useBuiltIns = _options$useBuiltIns === void 0 ? false : _options$useBuiltIns,
      transformRuntime = options.transformRuntime;
  var isTypeScriptEnabled = typescript;
  var conf = {
    presets: [[require.resolve('@babel/preset-env'), _objectSpread({
      targets: targets,
      loose: loose,
      modules: modules,
      useBuiltIns: useBuiltIns
    }, options.env)], isTypeScriptEnabled && [require.resolve('@babel/preset-typescript')]].filter(Boolean),
    plugins: [require.resolve('@babel/plugin-syntax-dynamic-import'), // Turn on legacy decorators for TypeScript files
    isTypeScriptEnabled && [require.resolve('@babel/plugin-proposal-decorators'), {
      "legacy": true
    }], [require.resolve('@babel/plugin-proposal-class-properties'), {
      loose: true
    }], require.resolve('@babel/plugin-transform-async-to-generator'), require.resolve('@babel/plugin-proposal-object-rest-spread'), require.resolve('@babel/plugin-proposal-export-namespace-from'), require.resolve('@babel/plugin-proposal-export-default-from'), // Polyfills the runtime needed for async/await, generators, and friends
    // https://babeljs.io/docs/en/babel-plugin-transform-runtime
    transformRuntime && [require.resolve('@babel/plugin-transform-runtime'), transformRuntime]].filter(Boolean)
  };

  if (presetReact && presetReact !== true) {
    conf.presets.push([require.resolve('@babel/preset-react'), presetReact]);
  } else if (presetReact) {
    conf.presets.push(require.resolve('@babel/preset-react'));
  }

  return conf;
} 
//# sourceMappingURL=index.js.map